diff -rN -u old-bordeaux-threads/src/bordeaux-threads.lisp new-bordeaux-threads/src/bordeaux-threads.lisp
--- old-bordeaux-threads/src/bordeaux-threads.lisp	2010-02-14 18:00:31.000000000 +0100
+++ new-bordeaux-threads/src/bordeaux-threads.lisp	2010-02-14 18:00:31.000000000 +0100
@@ -108,3 +108,6 @@
   (when (eq thread (current-thread))
     (error 'bordeaux-mp-condition
            :message "Cannot destroy the current thread")))
+
+
+(deftype bt:thread () '(satisfies bt:threadp))
diff -rN -u old-bordeaux-threads/src/impl-clozure.lisp new-bordeaux-threads/src/impl-clozure.lisp
--- old-bordeaux-threads/src/impl-clozure.lisp	2010-02-14 18:00:31.000000000 +0100
+++ new-bordeaux-threads/src/impl-clozure.lisp	2010-02-14 18:00:31.000000000 +0100
@@ -83,6 +83,7 @@
   (ccl:all-processes))
 
 (defun interrupt-thread (thread function &rest args)
+  (declare (dynamic-extent args))
   (apply #'ccl:process-interrupt thread function args))
 
 (defun destroy-thread (thread)
diff -rN -u old-bordeaux-threads/src/impl-mcl.lisp new-bordeaux-threads/src/impl-mcl.lisp
--- old-bordeaux-threads/src/impl-mcl.lisp	2010-02-14 18:00:31.000000000 +0100
+++ new-bordeaux-threads/src/impl-mcl.lisp	2010-02-14 18:00:31.000000000 +0100
@@ -9,7 +9,7 @@
 (in-package #:bordeaux-threads)
 
 (deftype thread ()
-  'ccl:process)
+  'ccl::process)
 
 ;;; Thread Creation
 
@@ -30,6 +30,17 @@
 (defun make-lock (&optional name)
   (ccl:make-lock (or name "Anonymous lock")))
 
+(defun acquire-lock (lock &optional (wait-p t))
+  (if wait-p
+    (ccl:process-lock lock ccl:*current-process*)
+    ;; this is broken, but it's better than a no-op
+    (ccl:without-interrupts
+     (when (null (ccl::lock.value lock))
+       (ccl:process-lock lock ccl:*current-process*)))))
+
+(defun release-lock (lock)
+  (ccl:process-unlock lock))
+
 (defmacro with-lock-held ((place) &body body)
   `(ccl:with-lock-grabbed (,place) ,@body))
 
@@ -42,6 +53,7 @@
   ccl:*all-processes*)
 
 (defun interrupt-thread (thread function &rest args)
+  (declare (dynamic-extent args))
   (apply #'ccl:process-interrupt thread function args))
 
 (defun destroy-thread (thread)

